"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "UseContext", {
    enumerable: true,
    get: function() {
        return UseContext;
    }
});
var _server = require("next/server");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _async_to_generator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _class_call_check(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}
function _defineProperties(target, props) {
    for(var i = 0; i < props.length; i++){
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
    }
}
function _create_class(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
}
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _instanceof(left, right) {
    if (right != null && typeof Symbol !== "undefined" && right[Symbol.hasInstance]) {
        return !!right[Symbol.hasInstance](left);
    } else {
        return left instanceof right;
    }
}
function _object_spread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _define_property(target, key, source[key]);
        });
    }
    return target;
}
function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable;
            });
        }
        keys.push.apply(keys, symbols);
    }
    return keys;
}
function _object_spread_props(target, source) {
    source = source != null ? source : {};
    if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
        ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
    }
    return target;
}
function _ts_generator(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return(g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g);
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
}
var UseContext = /*#__PURE__*/ function() {
    "use strict";
    function UseContext() {
        _class_call_check(this, UseContext);
    }
    _create_class(UseContext, [
        {
            key: "useFn",
            value: function useFn(fn) {
                var newBase = this.getBaseHandler();
                var myContextFunction = this.getContextFunction();
                // eslint-disable-next-line @typescript-eslint/no-var-requires
                var _require = require("./full-request-handler"), FRH = _require.FullRequestHandler;
                return new FRH(newBase, function() {
                    var _ref = _async_to_generator(function(data) {
                        var first, newContext, second, finalContext;
                        return _ts_generator(this, function(_state) {
                            switch(_state.label){
                                case 0:
                                    return [
                                        4,
                                        myContextFunction(data)
                                    ];
                                case 1:
                                    first = _state.sent();
                                    if (_instanceof(first, _server.NextResponse)) return [
                                        2,
                                        first
                                    ];
                                    newContext = _object_spread({}, data.context, first);
                                    return [
                                        4,
                                        fn(_object_spread_props(_object_spread({}, data), {
                                            context: newContext
                                        }))
                                    ];
                                case 2:
                                    second = _state.sent();
                                    if (_instanceof(second, _server.NextResponse)) return [
                                        2,
                                        second
                                    ];
                                    finalContext = _object_spread({}, newContext, second);
                                    return [
                                        2,
                                        finalContext
                                    ];
                            }
                        });
                    });
                    return function(data) {
                        return _ref.apply(this, arguments);
                    };
                }());
            }
        },
        {
            key: "useFullApi",
            value: function useFullApi(api) {
                var newBase = this.getBaseHandler().extend(api.getBaseHandler());
                var myContextFunction = this.getContextFunction();
                var otherContextFunction = api.getContextFunction();
                var reqHandler = function() {
                    var _ref = _async_to_generator(function(data) {
                        var first, newContext, second, finalContext;
                        return _ts_generator(this, function(_state) {
                            switch(_state.label){
                                case 0:
                                    return [
                                        4,
                                        myContextFunction(data)
                                    ];
                                case 1:
                                    first = _state.sent();
                                    if (_instanceof(first, _server.NextResponse)) return [
                                        2,
                                        first
                                    ];
                                    newContext = _object_spread({}, data.context, first);
                                    return [
                                        4,
                                        otherContextFunction(_object_spread_props(_object_spread({}, data), {
                                            context: newContext
                                        }))
                                    ];
                                case 2:
                                    second = _state.sent();
                                    if (_instanceof(second, _server.NextResponse)) return [
                                        2,
                                        second
                                    ];
                                    finalContext = _object_spread({}, newContext, second);
                                    return [
                                        2,
                                        finalContext
                                    ];
                            }
                        });
                    });
                    return function reqHandler(data) {
                        return _ref.apply(this, arguments);
                    };
                }();
                // eslint-disable-next-line @typescript-eslint/no-var-requires
                var _require = require("./full-request-handler"), FRH = _require.FullRequestHandler;
                return new FRH(newBase, reqHandler);
            }
        },
        {
            key: "use",
            value: function use(arg) {
                if (typeof arg === "function") {
                    return this.useFn(arg);
                }
                return this.useFullApi(arg);
            }
        }
    ]);
    return UseContext;
}();
